"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.vEnum = exports.vStruct = exports.vSome = exports.vNone = exports.vMap = exports.vSet = exports.vTuple = exports.vList = exports.vPublicKey = exports.vScalar = void 0;
const shared_1 = require("../shared");
const vScalar = (scalar) => {
    if (typeof scalar === 'number')
        return { kind: 'number', value: scalar };
    if (typeof scalar === 'boolean')
        return { kind: 'boolean', value: scalar };
    return { kind: 'string', value: scalar };
};
exports.vScalar = vScalar;
const vPublicKey = (value) => ({
    kind: 'publicKey',
    value,
});
exports.vPublicKey = vPublicKey;
const vList = (values) => ({
    kind: 'list',
    values,
});
exports.vList = vList;
const vTuple = (values) => ({
    kind: 'tuple',
    values,
});
exports.vTuple = vTuple;
const vSet = (values) => ({
    kind: 'set',
    values,
});
exports.vSet = vSet;
const vMap = (values) => ({
    kind: 'map',
    values,
});
exports.vMap = vMap;
const vNone = () => ({ kind: 'optionNone' });
exports.vNone = vNone;
const vSome = (value) => ({
    kind: 'optionSome',
    value,
});
exports.vSome = vSome;
const vStruct = (values) => ({
    kind: 'struct',
    values: Object.fromEntries(Object.entries(values).map(([key, value]) => [(0, shared_1.mainCase)(key), value])),
});
exports.vStruct = vStruct;
const vEnum = (enumType, variant, value, importFrom) => ({
    kind: 'enum',
    enumType: (0, shared_1.mainCase)(enumType),
    variant: (0, shared_1.mainCase)(variant),
    value: value !== null && value !== void 0 ? value : 'scalar',
    importFrom: importFrom !== null && importFrom !== void 0 ? importFrom : null,
});
exports.vEnum = vEnum;
//# sourceMappingURL=ValueNode.js.map