import type { IdlTypeEnumVariant } from '../idl';
import { MainCaseString } from '../shared';
import type { Node } from './Node';
import { StructTypeNode } from './StructTypeNode';
export type EnumStructVariantTypeNode = {
    readonly __enumStructVariantTypeNode: unique symbol;
    readonly kind: 'enumStructVariantTypeNode';
    readonly name: MainCaseString;
    readonly struct: StructTypeNode;
};
export declare function enumStructVariantTypeNode(name: string, struct: StructTypeNode): EnumStructVariantTypeNode;
export declare function enumStructVariantTypeNodeFromIdl(idl: IdlTypeEnumVariant): EnumStructVariantTypeNode;
export declare function isEnumStructVariantTypeNode(node: Node | null): node is EnumStructVariantTypeNode;
export declare function assertEnumStructVariantTypeNode(node: Node | null): asserts node is EnumStructVariantTypeNode;
