import { IdlInstructionAccount } from '../idl';
import { InstructionAccountDefault, MainCaseString, PartialExcept } from '../shared';
import type { Node } from './Node';
export type InstructionAccountNode = {
    readonly __instructionAccountNode: unique symbol;
    readonly kind: 'instructionAccountNode';
    readonly name: MainCaseString;
    readonly isWritable: boolean;
    readonly isSigner: boolean | 'either';
    readonly isOptional: boolean;
    readonly docs: string[];
    readonly defaultsTo?: InstructionAccountDefault;
};
export type InstructionAccountNodeInput = Omit<PartialExcept<InstructionAccountNode, 'isWritable' | 'isSigner'>, '__instructionAccountNode' | 'kind' | 'name'> & {
    name: string;
};
export declare function instructionAccountNode(input: InstructionAccountNodeInput): InstructionAccountNode;
export declare function instructionAccountNodeFromIdl(idl: IdlInstructionAccount): InstructionAccountNode;
export declare function isInstructionAccountNode(node: Node | null): node is InstructionAccountNode;
export declare function assertInstructionAccountNode(node: Node | null): asserts node is InstructionAccountNode;
