import { MainCaseString } from '../shared';
import { LinkTypeNode } from './LinkTypeNode';
import type { Node } from './Node';
import { StructTypeNode } from './StructTypeNode';
export type InstructionDataArgsNode = {
    readonly __instructionDataArgsNode: unique symbol;
    readonly kind: 'instructionDataArgsNode';
    readonly name: MainCaseString;
    readonly struct: StructTypeNode;
    readonly link?: LinkTypeNode;
};
export type InstructionDataArgsNodeInput = Omit<InstructionDataArgsNode, '__instructionDataArgsNode' | 'kind' | 'name'> & {
    name: string;
};
export declare function instructionDataArgsNode(input: InstructionDataArgsNodeInput): InstructionDataArgsNode;
export declare function isInstructionDataArgsNode(node: Node | null): node is InstructionDataArgsNode;
export declare function assertInstructionDataArgsNode(node: Node | null): asserts node is InstructionDataArgsNode;
