import type { Idl } from '../idl';
import { MainCaseString, PartialExcept } from '../shared';
import { AccountNode } from './AccountNode';
import { DefinedTypeNode } from './DefinedTypeNode';
import { ErrorNode } from './ErrorNode';
import { InstructionNode } from './InstructionNode';
import type { Node } from './Node';
export type ProgramNode = {
    readonly __programNode: unique symbol;
    readonly kind: 'programNode';
    readonly accounts: AccountNode[];
    readonly instructions: InstructionNode[];
    readonly definedTypes: DefinedTypeNode[];
    readonly errors: ErrorNode[];
    readonly name: MainCaseString;
    readonly prefix: MainCaseString;
    readonly publicKey: string;
    readonly version: string;
    readonly origin?: 'shank' | 'anchor';
    readonly internal: boolean;
};
export type ProgramNodeInput = Omit<PartialExcept<ProgramNode, 'accounts' | 'instructions' | 'definedTypes' | 'errors' | 'publicKey' | 'version'>, '__programNode' | 'kind' | 'name' | 'prefix'> & {
    name: string;
    prefix?: string;
};
export declare function programNode(input: ProgramNodeInput): ProgramNode;
export declare function programNodeFromIdl(idl: Partial<Idl>): ProgramNode;
export declare function isProgramNode(node: Node | null): node is ProgramNode;
export declare function assertProgramNode(node: Node | null): asserts node is ProgramNode;
